//*****************************************************************************
//*
//*
//*		ExcelImportX.cpp
//*
//*
//*****************************************************************************
#include	<tchar.h>
#include	<wchar.h>
#include	<stdio.h>
#include	<string.h>
#include	<AZ_Lib.h>
#include	"ExcelImportX.h"


#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	S			"S"
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	strzlen		wcslen
#define 	szprintf	swprintf
#else
#define 	S			"s"
#define 	Z(a)		a
#define 	zchar		char
#define 	strzlen		strlen
#define 	szprintf	sprintf
#endif


#define 	LOG_SECTORS		0
#define 	LOG_FOLDERS		0
#define 	LOG_IN_FILE		0
#define 	LOG_TOKENS		0
#define 	LOG_BINDUMP		0
#define 	LOG_TOKENLIST	0
#define 	LOG_FILENAME	"D:\\eee_%S_"



//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CExcelImportX::CExcelImportX()
{

	m_pCallbackProc	= ImportDummy;

	SetPassword(Z(""));

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CExcelImportX::~CExcelImportX()
{


}


//*****************************************************************************
//*
//*		ImportDummy
//*
//*****************************************************************************
void _cdecl CExcelImportX::ImportDummy(void *pParam,unsigned uSheet,unsigned uCol,unsigned uRow,int iType,const zchar *pData)
{

}

//*****************************************************************************
//*
//*		SetCallback
//*
//*****************************************************************************
//	Stellt den Callback fr gefundene Zellen ein
//	pParam,ExcelImportXCB *pProc
void CExcelImportX::SetCallback(void *pParam,ExcelImportXCB pProc)
{

	m_pCallbackParam	= pParam;
	m_pCallbackProc		= pProc;

	if(!m_pCallbackProc)m_pCallbackProc=ImportDummy;

}

//*****************************************************************************
//*
//*		SetPassword
//*
//*****************************************************************************
void CExcelImportX::SetPassword(const zchar *pPassWd)
{
unsigned	uLen;
unsigned	uPos;


	memset(m_aPasswd,0,sizeof(m_aPasswd));

	uLen = strzlen(pPassWd);

	if(uLen>64)uLen=64;

	for(uPos=0;uPos<uLen;uPos++)
		{
		#ifdef UNICODE
		m_aPasswd[uPos] = pPassWd[uPos];
		#else
		m_aPasswd[uPos] = pPassWd[uPos]&0xFF;
		#endif
		}

}

//*****************************************************************************
//*
//*		Open
//*
//*****************************************************************************
//	ffnet eine Excel-Datei.
//	pFilename		: Ist der Name der Excel-Datei.
//	Ergibt 0 wenn die Datei geffnet wurde, bzw. einen Fehler-Code:
//						1 = Datei konnte nicht geffnet werden.
//						2 = Falsches Dateiformat.
//						3 = BigEndian wird nicht untersttzt
//						4 = Zu wenig Speicher.
//						5 = Die Datei wird von einem anderen Programm benutzt
//						6 = Falsche BIFF-Version
//						7 = LOG-Datei konnte nicht geffnet werden
//						8 = Die Datei kann nicht decodiert werden
//						9 = Falsches Password
int	CExcelImportX::Open(const zchar *pFilename)
{
char		   *pMem;	
zchar			cName[0x10004];
char			cTemp[0x10004];
CStringChain	sStrings;	
CStringChain	sSheets;	
CZipFile		sZip;
int				iSheet;
int				iType;
int				iCnt;
int				iPos;
int				iLen;
int				iOff;
int				iAdd;
int				iNum;
int				iRow;
int				iCol;
int				iIdR;
int				iId;
int				i;	



	if(sZip.Open(pFilename)!=CZF_ERROR_OK)				// Iip-Datei ffnen
		{
		return 1;
		}


	   iPos = sZip.Find("xl/workbook.xml");		
	if(iPos<0)return 2;


	iLen = (int)sZip.Len(iPos);
	pMem = new char[iLen+8];

	if(!pMem)return 4;


	sSheets.DataLength(sizeof(int));
	sZip.ExtractMem(iPos,pMem,iLen+8);
	pMem[iLen] = 0;

	for(iOff=0;iOff<iLen;iOff++)						// Nullzeichen umwandeln
		{
		if(!pMem[iOff])pMem[iOff]=' ';
		}


	for(iOff=0;iOff<iLen;)								// Suche Bltternamen
		{
		   iAdd = strifind(pMem+iOff,"<sheet");
		if(iAdd<=0)break;

		iOff += iAdd+6;
		
		if(pMem[iOff]< 0 )continue;
		if(pMem[iOff]>' ')continue;

		cName[0] = 0;
		iIdR	 = 0;
		iId      = 0;

		while(iOff<iLen)								// Dekotiere  <sheet name="xxxx" sheetId="123" r:id="xxx"/>
			{
			if(pMem[iOff]=='>')break;
			if(pMem[iOff]<=' ')
				{
				iOff++;
				continue;
				}

			if(strnicmp(pMem+iOff,"name=",5)==0)
				{
				iOff  += 5;
				iOff  += strgetstr(cTemp,pMem+iOff,sizeof(cTemp));
				strawcpy(cName,cTemp,sizeof(cName)/sizeof(cName[0]));
				continue;
				}

			if(strnicmp(pMem+iOff,"sheetId=",8)==0)
				{
				iOff  += 8;
				iOff  += strgetstr(cTemp,pMem+iOff,sizeof(cTemp));
				iId	   = atoi(cTemp);			
				continue;
				}
			
			if(strnicmp(pMem+iOff,"r:id=",5)==0)
				{
				iOff  += 5;
				iOff  += strgetstr(cTemp,pMem+iOff,sizeof(cTemp));
				iIdR   = atoi(cTemp+strwlen(cTemp,0x06));			
				continue;
				}
			
			while(iOff<iLen)
				{
				if(pMem[iOff]=='>')break;
				if(pMem[iOff]=='"')
					{
					iOff++;
					iOff+=strchar(pMem+iOff,'"');
					iOff++;
					break;
					}
				
				if(pMem[iOff]<=' ')break;
				
				iOff++;
				}	
			
			}
		
		if(cName[0] && (iId>0 || iIdR>0))
			{
			if(iIdR>0)iId=iIdR;
			sSheets.Add(cName,CSC_END,&iId);
			}
		}

	delete pMem;

	if(sSheets.Count()<=0)return 2;
	

	sSheets.Sort(0,-1,CSC_SORT_INT);

	for(iSheet=1;iSheet<sSheets.Count();iSheet++)		// Auf doppelte Bltter prfen
		{
		   iNum =sSheets.DataGet(iSheet);
		if(iNum==sSheets.DataGet(iSheet-1))return 2;
		}


//******************** Strings laden ******************************************


	   iPos = sZip.Find("xl/sharedStrings.xml");		
	if(iPos<0)goto NoStrings;


	iLen = (int)sZip.Len(iPos);
	pMem = new char[iLen+8];

	if(!pMem)return 4;


	sSheets.DataLength(sizeof(int));
	sZip.ExtractMem(iPos,pMem,iLen+8);
	pMem[iLen] = 0;

	for(iOff=0;iOff<iLen;iOff++)						// Nullzeichen umwandeln
		{
		if(!pMem[iOff])pMem[iOff]=' ';
		}


	for(iOff=0;iOff<iLen;)								// Suche Bltternamen
		{
		   iAdd = strifind(pMem+iOff,"<si");
		if(iAdd<0)break;

		iOff += iAdd+3;

		if(strwchar(pMem[iOff],0x0F))continue;

		for(;iOff<iLen;iOff++)
			{
			if(pMem[iOff]=='>')break;
			}

		if(pMem[iOff]!='>')continue;

		iOff++;

		   iAdd = strifind(pMem+iOff,"<t");
		if(iAdd<0)break;
		
		iOff += iAdd+2;

		if(strwchar(pMem[iOff],0x0F))continue;
		
		for(;iOff<iLen;iOff++)
			{
			if(pMem[iOff]=='>')break;
			}

		if(pMem[iOff]!='>')continue;

		iOff++;

		iNum  = strhtmldecode(pMem+iOff,iLen-iOff,cTemp,sizeof(cTemp),0x0B,&iAdd);
		iOff += iAdd;
			
		sStrings.Add(iNum,cTemp);
		}

	delete pMem;


//******************** Bltter dekodieren *************************************
NoStrings:

	for(iSheet=0;iSheet<sSheets.Count();iSheet++)		// Auf doppelte Bltter prfen
		{
		iNum = sSheets.DataGet(iSheet);
		sprintf(cTemp,"xl/worksheets/sheet%i.xml",iNum);

		   iPos = sZip.Find(cTemp);		
		if(iPos<0)return 2;

		iLen = (int)sZip.Len(iPos);
		pMem = new char[iLen+8];

		if(!pMem)return 4;

		sZip.ExtractMem(iPos,pMem,iLen+8);
		pMem[iLen] = 0;

		for(iOff=0;iOff<iLen;iOff++)					// Nullzeichen umwandeln
			{
			if(!pMem[iOff])pMem[iOff]=' ';
			}


		   iOff = strifind(pMem,"<sheetData");
		if(iOff<0 || (pMem[iOff+10]>' ' && pMem[iOff+10]!='/' && pMem[iOff+10]!='>'))
			{
			delete pMem;
			return 2;
			}

														// Callback fr Blatt
		m_pCallbackProc(m_pCallbackParam,iNum,0,0,CEX_TYPE_SHEET,sSheets[iSheet]);

		
		while(iOff<iLen)
			{
			if(pMem[iOff]=='"')
				{
				iOff++;
				iOff+=strchar(pMem+iOff,'"');
				iOff++;
				continue;
				}

			if(pMem[iOff]!='<')							// Nchster Tag
				{
				iOff++;
				continue;
				}

			iOff++;

			if(pMem[iOff]!='c' && pMem[iOff]!='C')		// Neue Zelle
				{
				iOff++;
				continue;
				}

			if(strwchar(pMem[iOff+1],0x07))
				{
				iOff++;
				continue;
				}

			cTemp[0] = 0;
			iType    = CEX_TYPE_NUMBER;
			
			for(iOff+=2;iOff<iLen;iOff++)				// Suche Zellenindex	
				{
				if(pMem[iOff  ]=='>')break;
				if(pMem[iOff  ]!='r' && pMem[iOff]!='R')
				if(pMem[iOff  ]!='t' && pMem[iOff]!='T')continue;
				if(pMem[iOff+1]!='='                   )continue;
				if(strwchar(pMem[iOff-1],0x07)         )continue;
				if(pMem[iOff  ]=='t'|| pMem[iOff ]=='T')
					{
					iOff += 2;
					iOff += strgetstr(cTemp+16,pMem+iOff,sizeof(cTemp))-1;

					if(cTemp[16]=='s' || cTemp[16]=='S')
						{
						iType = CEX_TYPE_TEXT;
						}

					continue;
					}

				iOff += 2;
				iOff += strgetstr(cTemp,pMem+iOff,sizeof(cTemp))-1;
				}
			
			if(!cTemp[0] || pMem[iOff]!='>')
				{
				continue;
				}

			iOff++;
														// Zellenindex
			for(iCol=0,i=0;cTemp[i]>='A' && cTemp[i]<='Z';i++)
				{
				iCol *= 26;
				iCol += cTemp[i]-'A'+1;
				}

			for(iRow=0;cTemp[i]>='0' && cTemp[i]<='9';i++)
				{
				iRow *= 10;
				iRow += cTemp[i]-'0';
				}
			
			if(cTemp[i] || !iRow || !iCol)continue;

			iCol--;
			iRow--;

			for(;iOff<iLen;iOff++)						// Suche Zelleninhalt
				{
				if(pMem[iOff  ]!='<')continue;
				if(pMem[iOff+1]=='/')
				if(pMem[iOff+2]=='c' || pMem[iOff+2]=='C')
				if(!strwchar(pMem[iOff+3],0x07))
					{
					iOff+=4;
					break;
					}

				if(pMem[iOff+1]=='c' || pMem[iOff+1]=='C' && !strwchar(pMem[iOff+2],0x07))
					{
					break;								// Nchste Zelle
					}

				if(pMem[iOff+1]!='v' && pMem[iOff+1]!='V')
					{
					continue;
					}

				if(strwchar(pMem[iOff+2],0x07))
					{
					continue;
					}

				iOff += 2;

				while(iOff<iLen)						// Ans Enden von <v>
					{
					iOff++;
					if(pMem[iOff-1]=='>')break;	
					}
				
					i = strchar(pMem+iOff,'<');
				if(!i)break;

				
				
				if(iType==CEX_TYPE_TEXT)
					{
					iAdd  = strwlen(pMem+iOff,0xE0);
					iId   = strtoi (pMem+iOff+iAdd,0,&iCnt);					
					iAdd += iCnt;
					iAdd += strwlen(pMem+iOff+iAdd,0xE0);
					
					if(iId>=0 && iId<sStrings.Count() && iCnt>0 && pMem[iOff+iAdd]=='<')
						{
						m_pCallbackProc(m_pCallbackParam,iNum,iCol,iRow,iType,sStrings[iId]);
						iOff+=i;
						break;
						}
					}

				strfromutf8(cName,pMem+iOff,sizeof(cName)/sizeof(cName[0]),i);
				
														// Callback fr Zelle
				m_pCallbackProc(m_pCallbackParam,iNum,iCol,iRow,iType,cName);
				
				iOff+=i;
				break;
				}
			}
		
		delete pMem;
		}

	


return 0;
}

